#ifndef FtpCommandDialog_h
#define FtpCommandDialog_h

/******************************************************************************
*
* Copyright (C) 2002 Hugo PEREIRA <mailto: hugo.pereira@free.fr>
*
* This is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
*
* This software is distributed in the hope that it will be useful, but WITHOUT
* Any WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
* for more details.
*
* You should have received a copy of the GNU General Public License along with
* this program.  If not, see <http://www.gnu.org/licenses/>.
*
*******************************************************************************/

#include "CustomDialog.h"
#include "Counter.h"
#include "FtpCommandModel.h"
#include "FtpMacroModel.h"

class TreeView;

namespace Ftp
{
    class CommandDialog: public CustomDialog
    {

        Q_OBJECT

        public:

        //* constructor
        explicit CommandDialog( QWidget* = nullptr );

        //*@name accessors
        //@{

        TreeView& macroList() const
        { return *macroList_; }

        TreeView& commandList() const
        { return *commandList_; }

        //@}

        //*@name modifiers
        //@{

        MacroModel& macroModel()
        { return macroModel_; }

        CommandModel& commandModel()
        { return commandModel_; }

        //@}

        Q_SIGNALS:

        //* emitted when hidden
        void dialogHidden();

        protected:

        //* hide event
        void closeEvent( QCloseEvent* ) override;

        private:

        //* models
        MacroModel macroModel_;
        CommandModel commandModel_;

        //* lists
        TreeView* macroList_ = nullptr;
        TreeView* commandList_ = nullptr;

    };

}

#endif
